/*
 *	pixie.c
 *
 */
#include "app.h"


PIXIE pixies[N_PIXIES];

void
pixie_init()
{

	/* XvCge[uNA܂B */
	memset(pixies, 0, sizeof pixies);
}

void
pixie_update()
{
	int i_sprite, i_pixie, col, row, x, y;
	unsigned short chr, *pchr;
	PIXIE* pixie;
	BLOCK* block;

	i_sprite = 0;
	for(i_pixie = 0, pixie = pixies; i_pixie < N_PIXIES; i_pixie++, pixie++) {
		block = pixie->block;
		if(block == NULL) continue;
		pchr = block->chrs;
		for(row = 0, y = pixie->y; row < block->rows; row++, y += 8) {
			for(col = 0, x = pixie->x; col < block->cols; col++, x += 8) {
				chr = *pchr++;
				if(chr == 0) continue;
				if(x < -8 || DISP_X <= x) continue;
				if(y < -8 || DISP_Y <= y) continue;
				pclSpriteSetCharacter(i_sprite++, x, y, chr);
				if(i_sprite == N_SPRITES) goto L10;
			}
		}
		while(i_sprite < N_SPRITES) {
			pclSpriteSetCharacter(i_sprite++, -8, -8, 0);
		}
L10:

	}

}
